<script lang="ts">
  import { onMount } from 'svelte';
  import { eventId } from '@stores';
  import type { Team } from '@models/Team';
  import { GetAllTeams } from '@models/Team';
  import type { DisplayedService } from '@models/Service';
  import { GetDisplayedServices } from '@models/Service';
  import ServiceStatusElement from '@components/ServiceStatusTable/ServiceStatusElement.svelte';
  import { Spinner, Table } from '@sveltestrap/sveltestrap';
  import { faEyeSlash } from '@fortawesome/free-solid-svg-icons';
  import type { ScoreBoardAdversarialStatus } from '@models/Adversarial';
  import { Gql } from '@db';
  import Fa from 'svelte-fa';

  export let shortNames: boolean = true;

  let scoreboardTeams: Team[] = [];
  let checks: DisplayedService[] = [];
  let serviceStatuses: ScoreBoardAdversarialStatus[] = [];
  let hidden_checks = [];
  let hidden_teams = [];
  $: console.log('hidden checks', hidden_checks);
  $: console.log('hidden teams', hidden_teams);

  const q = `subscription ScoreboardAdversarialStatus {
    scoreboard_adversarial_status {
      data
      last_success
      last_partial
      last_failure
      last_error
      check_time
      check_order
      participant
      result_code
      staff
      team_order
      visible
      team_id
      event_id
      check_id
    }
  }`;

  onMount(async () => {
    checks = await GetDisplayedServices($eventId, 'adversarial');
    scoreboardTeams = await GetAllTeams($eventId);
    Gql.subscribeSimple<{ scoreboard_adversarial_status: ScoreBoardAdversarialStatus[] }>(
      q,
      (data) => (serviceStatuses = data.scoreboard_adversarial_status),
    );
  });
</script>

<div class="service-statuses">
  <Table>
    <thead>
      <tr>
        <th />
        <th />
        {#each scoreboardTeams as t}
          {#if !hidden_teams.includes(t.id)}
            <th scope="row">
              <div>
                <span class="clickable" on:click={() => (hidden_teams = [...hidden_teams, t.id])}>
                  <Fa icon={faEyeSlash} />
                </span>
                {t.name}
                {#if !shortNames && t.long_name}
                  <p class="my-0">{t.long_name}</p>
                {/if}
              </div>
            </th>
          {/if}
        {/each}
      </tr>
    </thead>
    {#key serviceStatuses}
      <tbody>
        {#each checks as c}
          {#if !hidden_checks.includes(c.check_id)}
            <tr>
              <th class="pe-1">
                <span class="clickable" on:click={() => (hidden_checks = [...hidden_checks, c.check_id])}>
                  <Fa icon={faEyeSlash} />
                </span>
              </th>

              <th>
                <div class="sq sq-label sq-service">
                  {c.check.display_name}
                </div>
              </th>

              {#each scoreboardTeams as t}
                {#if !hidden_teams.includes(t.id)}
                  <td>
                    {#await serviceStatuses.find((s) => s.team_id === t.id && s.check_id === c.check_id) then status}
                      {#if status}
                        <ServiceStatusElement {status} />
                      {:else}
                        <Spinner />
                      {/if}
                    {/await}
                  </td>
                {/if}
              {/each}
            </tr>
          {/if}
        {/each}
      </tbody>
    {/key}
  </Table>
</div>

<style>
  .service-statuses,
  .sq {
    display: flex;
    flex-flow: row nowrap;
    align-content: center;
    justify-content: center;
  }

  .sq {
    flex-flow: column nowrap;
  }

  .sq {
    color: white;
    border: 1px solid #252525;
    font-weight: bold;
    text-align: center;

    min-height: 2.5em;
    min-width: 4em;
  }

  .sq-label {
    border: 0;
    padding: 0 0.4em;
    text-shadow: 1px 1px 10px #888;
  }

  @media (max-width: 768px) {
    /* Transpose services display matrix */
    .service-statuses {
      flex-flow: column wrap;
      display: inline-flex;
      align-content: flex-start;
    }

    /* adjust row sizes, add banding effect, tilt team names upwards */
    .sq {
      font-size: 0.8em;
      min-height: 4em;
    }
  }

  /* Phonies */
  @media (max-width: 450px) {
    .sq {
      font-size: 0.6em;
      min-height: 5em;
    }

    .sq-service {
      font-size: 0.74em;
    }
  }

  .sq-service:first-child {
    /* Remove padding between first service and the table controls */
    padding-left: 0;
  }
</style>
